--- feeds/luci/modules/luci-base/luasrc/tools/status.lua	2016-01-01 16:41:00.000000000 +0800
+++ feeds/luci/modules/luci-base/luasrc/tools/status.lua	2016-06-05 10:10:54.557855800 +0800
@@ -1,4 +1,5 @@
 -- Copyright 2011 Jo-Philipp Wich <jow@openwrt.org>
+-- Marvell switch status reads by animefans_xj <af_xj@hotmail.com>
 -- Licensed to the public under the Apache License 2.0.
 
 module("luci.tools.status", package.seeall)
@@ -182,24 +183,38 @@
 			repeat
 				l = swc:read("*l")
 				if l then
-					local port, up = l:match("port:(%d+) link:(%w+)")
-					if port then
-						local speed  = l:match(" speed:(%d+)")
-						local duplex = l:match(" (%w+)-duplex")
-						local txflow = l:match(" (txflow)")
-						local rxflow = l:match(" (rxflow)")
-						local auto   = l:match(" (auto)")
-
-						ports[#ports+1] = {
-							port   = tonumber(port) or 0,
-							speed  = tonumber(speed) or 0,
-							link   = (up == "up"),
-							duplex = (duplex == "full"),
-							rxflow = (not not rxflow),
-							txflow = (not not txflow),
-							auto   = (not not auto)
-						}
+					if l:match("Port (%d+):") then
+						local port = l:match("Port (%d+):")
+						local up, speed, deplex, txflow, rxflow, auto
+						while true do
+							l = swc:read("*l")
+							if l then
+								if l:match("status: link: (%l+)") then
+									up     = l:match("status: link: (%w+)")
+									speed  = l:match(" speed: (%d+)")
+									duplex = l:match(" duplex: (%w+)")
+									txflow = l:match(" (txflow)")
+									rxflow = l:match(" (rxflow)")
+									auto   = l:match(" (auto)")
+
+									ports[#ports+1] = {
+										port   = tonumber(port) or 0,
+										speed  = tonumber(speed) or 0,
+										link   = (up == "up"),
+										duplex = (duplex == "full"),
+										rxflow = (not not rxflow),
+										txflow = (not not txflow),
+										auto   = (not not auto)
+									}
+									break
+								end
+							else
+								break
+							end
+						end	
+
 					end
+
 				end
 			until not l
 			swc:close()
